var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var produce_exports = {};
__export(produce_exports, {
  ProduceJWT: () => ProduceJWT
});
module.exports = __toCommonJS(produce_exports);
var import_epoch = __toESM(require("../lib/epoch.js"));
var import_is_object = __toESM(require("../lib/is_object.js"));
var import_secs = __toESM(require("../lib/secs.js"));
class ProduceJWT {
  constructor(payload) {
    if (!(0, import_is_object.default)(payload)) {
      throw new TypeError("JWT Claims Set MUST be an object");
    }
    this._payload = payload;
  }
  setIssuer(issuer) {
    this._payload = __spreadProps(__spreadValues({}, this._payload), { iss: issuer });
    return this;
  }
  setSubject(subject) {
    this._payload = __spreadProps(__spreadValues({}, this._payload), { sub: subject });
    return this;
  }
  setAudience(audience) {
    this._payload = __spreadProps(__spreadValues({}, this._payload), { aud: audience });
    return this;
  }
  setJti(jwtId) {
    this._payload = __spreadProps(__spreadValues({}, this._payload), { jti: jwtId });
    return this;
  }
  setNotBefore(input) {
    if (typeof input === "number") {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { nbf: input });
    } else {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { nbf: (0, import_epoch.default)(new Date()) + (0, import_secs.default)(input) });
    }
    return this;
  }
  setExpirationTime(input) {
    if (typeof input === "number") {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { exp: input });
    } else {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { exp: (0, import_epoch.default)(new Date()) + (0, import_secs.default)(input) });
    }
    return this;
  }
  setIssuedAt(input) {
    if (typeof input === "undefined") {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { iat: (0, import_epoch.default)(new Date()) });
    } else {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { iat: input });
    }
    return this;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ProduceJWT
});
