var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var asn1_sequence_decoder_exports = {};
__export(asn1_sequence_decoder_exports, {
  default: () => Asn1SequenceDecoder
});
module.exports = __toCommonJS(asn1_sequence_decoder_exports);
const tagInteger = 2;
const tagSequence = 48;
class Asn1SequenceDecoder {
  constructor(buffer) {
    if (buffer[0] !== tagSequence) {
      throw new TypeError();
    }
    this.buffer = buffer;
    this.offset = 1;
    const len = this.decodeLength();
    if (len !== buffer.length - this.offset) {
      throw new TypeError();
    }
  }
  decodeLength() {
    let length = this.buffer[this.offset++];
    if (length & 128) {
      const nBytes = length & ~128;
      length = 0;
      for (let i = 0; i < nBytes; i++)
        length = length << 8 | this.buffer[this.offset + i];
      this.offset += nBytes;
    }
    return length;
  }
  unsignedInteger() {
    if (this.buffer[this.offset++] !== tagInteger) {
      throw new TypeError();
    }
    let length = this.decodeLength();
    if (this.buffer[this.offset] === 0) {
      this.offset++;
      length--;
    }
    const result = this.buffer.slice(this.offset, this.offset + length);
    this.offset += length;
    return result;
  }
  end() {
    if (this.offset !== this.buffer.length) {
      throw new TypeError();
    }
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
