var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var verify_exports = {};
__export(verify_exports, {
  default: () => verify_default
});
module.exports = __toCommonJS(verify_exports);
var crypto = __toESM(require("crypto"));
var import_util = require("util");
var import_dsa_digest = __toESM(require("./dsa_digest.js"));
var import_node_key = __toESM(require("./node_key.js"));
var import_sign = __toESM(require("./sign.js"));
var import_get_sign_verify_key = __toESM(require("./get_sign_verify_key.js"));
const [major, minor] = process.version.slice(1).split(".").map((str) => parseInt(str, 10));
const oneShotCallbackSupported = major >= 16 || major === 15 && minor >= 13;
let oneShotVerify;
if (crypto.verify.length > 4 && oneShotCallbackSupported) {
  oneShotVerify = (0, import_util.promisify)(crypto.verify);
} else {
  oneShotVerify = crypto.verify;
}
const verify = async (alg, key, signature, data) => {
  const keyObject = (0, import_get_sign_verify_key.default)(alg, key, "verify");
  if (alg.startsWith("HS")) {
    const expected = await (0, import_sign.default)(alg, keyObject, data);
    const actual = signature;
    try {
      return crypto.timingSafeEqual(actual, expected);
    } catch {
      return false;
    }
  }
  const algorithm = (0, import_dsa_digest.default)(alg);
  const keyInput = (0, import_node_key.default)(alg, keyObject);
  try {
    return await oneShotVerify(algorithm, data, keyInput, signature);
  } catch {
    return false;
  }
};
var verify_default = verify;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
