var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var rsaes_exports = {};
__export(rsaes_exports, {
  decrypt: () => decrypt,
  encrypt: () => encrypt
});
module.exports = __toCommonJS(rsaes_exports);
var import_subtle_rsaes = __toESM(require("./subtle_rsaes.js"));
var import_bogus = __toESM(require("./bogus.js"));
var import_webcrypto = __toESM(require("./webcrypto.js"));
var import_crypto_key = require("../lib/crypto_key.js");
var import_check_key_length = __toESM(require("./check_key_length.js"));
var import_invalid_key_input = __toESM(require("../lib/invalid_key_input.js"));
var import_is_key_like = require("./is_key_like.js");
const encrypt = async (alg, key, cek) => {
  if (!(0, import_webcrypto.isCryptoKey)(key)) {
    throw new TypeError((0, import_invalid_key_input.default)(key, ...import_is_key_like.types));
  }
  (0, import_crypto_key.checkEncCryptoKey)(key, alg, "encrypt", "wrapKey");
  (0, import_check_key_length.default)(alg, key);
  if (key.usages.includes("encrypt")) {
    return new Uint8Array(await import_webcrypto.default.subtle.encrypt((0, import_subtle_rsaes.default)(alg), key, cek));
  }
  if (key.usages.includes("wrapKey")) {
    const cryptoKeyCek = await import_webcrypto.default.subtle.importKey("raw", cek, ...import_bogus.default);
    return new Uint8Array(await import_webcrypto.default.subtle.wrapKey("raw", cryptoKeyCek, key, (0, import_subtle_rsaes.default)(alg)));
  }
  throw new TypeError('RSA-OAEP key "usages" must include "encrypt" or "wrapKey" for this operation');
};
const decrypt = async (alg, key, encryptedKey) => {
  if (!(0, import_webcrypto.isCryptoKey)(key)) {
    throw new TypeError((0, import_invalid_key_input.default)(key, ...import_is_key_like.types));
  }
  (0, import_crypto_key.checkEncCryptoKey)(key, alg, "decrypt", "unwrapKey");
  (0, import_check_key_length.default)(alg, key);
  if (key.usages.includes("decrypt")) {
    return new Uint8Array(await import_webcrypto.default.subtle.decrypt((0, import_subtle_rsaes.default)(alg), key, encryptedKey));
  }
  if (key.usages.includes("unwrapKey")) {
    const cryptoKeyCek = await import_webcrypto.default.subtle.unwrapKey("raw", encryptedKey, key, (0, import_subtle_rsaes.default)(alg), ...import_bogus.default);
    return new Uint8Array(await import_webcrypto.default.subtle.exportKey("raw", cryptoKeyCek));
  }
  throw new TypeError('RSA-OAEP key "usages" must include "decrypt" or "unwrapKey" for this operation');
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  decrypt,
  encrypt
});
