var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var decode_jwt_exports = {};
__export(decode_jwt_exports, {
  decodeJwt: () => decodeJwt
});
module.exports = __toCommonJS(decode_jwt_exports);
var import_base64url = require("./base64url.js");
var import_buffer_utils = require("../lib/buffer_utils.js");
var import_is_object = __toESM(require("../lib/is_object.js"));
var import_errors = require("./errors.js");
function decodeJwt(jwt) {
  if (typeof jwt !== "string")
    throw new import_errors.JWTInvalid("JWTs must use Compact JWS serialization, JWT must be a string");
  const { 1: payload, length } = jwt.split(".");
  if (length === 5)
    throw new import_errors.JWTInvalid("Only JWTs using Compact JWS serialization can be decoded");
  if (length !== 3)
    throw new import_errors.JWTInvalid("Invalid JWT");
  if (!payload)
    throw new import_errors.JWTInvalid("JWTs must contain a payload");
  let decoded;
  try {
    decoded = (0, import_base64url.decode)(payload);
  } catch {
    throw new import_errors.JWTInvalid("Failed to parse the base64url encoded payload");
  }
  let result;
  try {
    result = JSON.parse(import_buffer_utils.decoder.decode(decoded));
  } catch {
    throw new import_errors.JWTInvalid("Failed to parse the decoded payload as JSON");
  }
  if (!(0, import_is_object.default)(result))
    throw new import_errors.JWTInvalid("Invalid JWT Claims Set");
  return result;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  decodeJwt
});
